############
# simple web server
import apache
import BaseHTTPServer
import os
import string
import sys
import traceback
import types

def default_handler(req):
  return apache.HTTP_NOT_FOUND

user_handler = default_handler

class LocalHandler(BaseHTTPServer.BaseHTTPRequestHandler):
  def setHandler(self, handler):
    self.handler = handler
    
  def __do_request(self):
    print "Request uri: ", self.path
    try:
      # build file to send
      print self.headers
      req = apache.Request(self)
      result = user_handler(req)
      print "HTTP result: ", result
      if type(result) != types.IntType:
          result = apache.HTTP_INTERNAL_SERVER_ERROR
      # send file
      if result != apache.OK:
        return self.do_errorpage(result, req)
      else:
        self.send_response(result)
        self.send_header('Content-Type', req.content_type)
        self.send_header('Content-Length', req.len)
        self.end_headers()

      return req.getvalue()
    except Exception, e:
      print "exception happened"
      print e
      t,v,tb = sys.exc_info()
      exception_list = traceback.format_exception(t,v,tb)
      error = ["<html><body><h1>Error %d</h1>" % apache.HTTP_INTERNAL_SERVER_ERROR]
      error +=["<p>Bummer: something went wrong</p>"]
      error +=["<pre>"]
      error.extend(exception_list)
      error +=["</pre>"]
      error +=["</body></html>"]
      error = string.join(error, os.linesep)
      print string.join(exception_list, os.linesep)
      self.send_response(apache.HTTP_INTERNAL_SERVER_ERROR)
      self.send_header('Content-Type', 'text/html')
      self.send_header('Content-Length', len(error))
      self.end_headers()
      return error

  def do_GET(self):
    self.wfile.write(self.__do_request())

  def do_POST(self):
    self.wfile.write(self.__do_request())

  def do_HEAD(self):
    self.__do_request()

  def do_errorpage(self, result_code, request):
    """Return error page if something went wrong
    """
    error = ["<html><body><h1>Error %d</h1>" % result_code]
    error +=["<p>Bummer: something went wrong with the following request.</p>"]
    error +=["<p>%s</p>" % (request.uri)]
    error +=["</body></html>"]
    error = string.join(error, os.linesep)
    self.send_response(result_code)
    self.send_header('Content-Type', 'text/html')
    self.send_header('Content-Length', len(error))
    self.end_headers()
    return error
  
def run(handler,
        server_class=BaseHTTPServer.HTTPServer,
        handler_class=LocalHandler):
  global user_handler
  user_handler = handler
  server_address = ('', 8001)
  httpd = server_class(server_address, handler_class)
  httpd.serve_forever()

