"""Provide a examples that can be loaded mostly for the testing code
"""
import os

from compClust.mlx import datasets
from compClust.mlx import labelings

def LoadCho():
  # Either grab the environment variable CHO_DATA (which is set in
  # setup.py or hope that the relative path is ok)
  dataroot = os.environ.get('CHO_DATA', "../gui/Examples/ChoCellCycling")
  
  # load data
  ds = datasets.Dataset(os.path.join(dataroot,"ChoCycling.dat"))
    
  # load some labelings
  cho = labelings.GlobalLabeling(ds, "Cho")
  cho.labelRows(ds, os.path.join(dataroot, "ChoClassification.rlab"))
  common = labelings.GlobalLabeling(ds,"common name")
  common.labelRows(ds, os.path.join(dataroot, "CommonNames.rlab"))
  orfs = labelings.GlobalLabeling(ds, "orfs")
  orfs.labelRows(ds, os.path.join(dataroot, "ORFs.rlab"))
  em = labelings.GlobalLabeling(ds, "diagem")
  em.labelRows(ds, os.path.join(dataroot, "EM.rlab"))
  times = labelings.GlobalLabeling(ds,"Time Points")
  times.labelCols(ds, os.path.join(dataroot, "times.clab"))

  return (ds, {'commonName': common, 'choCluster': cho, 'diagemCluster': em})
