#!/usr/bin/env python

import getopt
import os
import sys

from twisted.internet import reactor

from quixote.server import twisted_http

# Server that exposes the links demo program on port 8080
PORT = 8001

from compClust.gui import CompClustWeb
from compClust.gui.CompClustWebSession import CompClustWebSession, \
                                              CompClustWebSessionManager, \
                                              CompClustWebPublisher, \
                                              datamanager

def create_webserver():
  print 'Now serving the qxdemo.links demo on port %i' % PORT
  CompClustWeb.ROOT_URL="/"
  publisher = CompClustWebPublisher()

  qf = twisted_http.QuixoteFactory(publisher)
  reactor.listenTCP(PORT, qf)
  return reactor

# NOTE: if i keep going with the idea of datamanager managing all the
# NOTE: datasources including defining which are accessible, then just
# NOTE: providing access to the datamanager object will let me play with
# NOTE: the app from the interpreter. (ergo this code fragment is
# NOTE: unnecessary)
#def get_session(user=None):
#  """Return session for the currently running user.
#  """
#  if user is None:
#    if CompClustWebSession.force_user is not None:
#      user = CompClustWebSession.force_user
#    else:
#      user = os.getlogin()
#      
#  user_sessions = [ x for x in persistent_sessions.values() if x.user == user]
#  if len(user_sessions) == 0:
#    raise KeyError("user %s not found" % user)
#  elif len(user_sessions) > 1:
#    # FIXME: should this raise an error?
#    print "user %s logged in several times" % user
#    return user_sessions
#  else:
#    return user_sessions[0]


def start_webserver(threading=False):
  server = create_webserver()
  mode = 'thread'
  print "starting webserver"
  if threading:
    try:
      import thread
      thread.start_new_thread(server.run, (None,))
    except ImportError, e:
      import threading
      class s(threading.Thread):
        def __init__(self, group=None, target=None, name=None, args=(), kwargs={}):
          self.handler = args[0]
        def run():
          server.run()
      sThread = s()
      sThread.setDaemon(1)
      sThread.start()
  else:
    server.run()

def getlogin():
  """Get login, since on my system os.getlogin has a bug,
  this is a work around which will also try some unixisms to get the
  default user.
  """
  try:
    return os.getlogin()
  except OSError, e:
    # try the environment
    if os.environ.has_key('USER'):
      return os.environ['USER']
    elif os.enviorn.has_key('USERNAME'):
      return os.environ['USERNAME']
    else:
      return 'compclust'
    
def usage():
  print "compclustweb-local driver script"
  print "-h[elp] this usage help."
  print "-u[ser] force application to login as a  specific user"
  print "-s[hared] run in multiuser mode <prevents -user mode>"
  
if __name__ == "__main__":
  # parse arguments
  CompClustWebSession.force_user = getlogin()
  
  opts, args = getopt.getopt(sys.argv[1:], "hu:s", ["help", "user=", "shared"])
  for opt, optval in opts:
    if opt in ('-h', '--help'):
      print usage()
    elif opt in ('-u', '--user'):
      if optval is None:
        optval = os.getlogin()
      print "setting user to", optval
      CompClustWebSession.force_user = optval
    elif opt in ('-s', '--shared'):
      CompClustWebSession.force_user = None
      
  # launch app
  threading = True
  start_webserver(threading)
  if threading:
    from IPython.Shell import IPythonShellEmbed
    ipshell = IPythonShellEmbed()
    ipshell()
